# Summary

[Laboratoare PCom 🌐](labs.md)

# 01. Networking warmup
----
- [Lectură laborator](lab1/lecture.md)
- [Despre laboratoarele de PCom](lab1/about.md)
- [Nivelul fizic](lab1/physical.md)
- [Internetul](lab1/internet.md)
- [Networking de mână](lab1/manual_networking.md)
- [Monitorizarea traficului](lab1/monitoring.md)
  - [Wireshark](lab1/wireshark.md)
  - [tcpdump](lab1/tcpdump.md)
- [Noțiuni generale de programare](lab1/basic_c.md)
  - [Compilare](lab1/compilation.md)
  - [Debugging](lab1/debugging.md)
  - [File descriptors](lab1/files.md)
- [Exerciții](lab1/exercises.md)

# 02. Datalink. Framing
----

- [Lectură laborator](lab2/lecture.md)
- [Framing](lab2/theoretical_intro.md)
  - [Bit Stuffing](lab2/bit_stuffing.md)
  - [Character (byte) stuffing](lab2/practical_bit_stuffing.md)
- [Tipuri de comunicatie](lab2/types.md)
  - [Point-to-Point](lab2/point_to_point.md)
  - [Point-to-Multipoint](lab2/point_to_multipoint.md)
- [Metrici](lab2/metrics.md)
- [Exerciții](lab2/exercises.md)

# 03. Transfer de date peste un link imperfect.
----

- [Lectură laborator](lab3/lecture.md)
- [Detectarea și corectarea erorilor de transmisie](lab3/error_detection.md)
- [Sume de control](lab3/checksum.md)
- [Endianness](lab3/endianness.md)
- [Cyclic Redundancy Codes (CRCs)](lab3/crc.md)
- [Exerciții](lab3/exercises.md)

# 04. Protocolul IP. Forwarding
----

- [Lectură laborator](lab4/lecture.md)
- [Routing](lab4/routing.md)
- [Protocoale utilizate](lab4/protocols.md)
  - [Ethernet](lab4/ethernet.md)
  - [IPV4](lab4/ipv4.md)
    - [Adrese IP](lab4/ip_addresses.md)
- [Procesul de forward](lab4/forwarding.md)
  - [Longest Prefix Match](lab4/lpm.md)
- [Infrastrucutra](lab4/setup.md)
- [Testare](lab4/testing.md)
- [Exerciții](lab4/exercises.md)

# 05. Procolul UDP. Fereastra glisanta. Mininet.
----
- [Lectură laborator](lab6/lecture.md)
- [Setup](lab6/setup.md)
- [Nivelul Transport](lab6/transport.md)
  - [Porturi](lab6/ports.md)
- [Protocolul UDP](lab6/udp.md)
  - [Header UDP](lab6/udp_header.md)
- [Sockets](lab6/sockets.md)
  - [Comunicare client-server UNIX](lab6/client_serv.md)
  - [socket()](lab6/create_socket.md)
  - [bind()](lab6/bind.md)
  - [struct sockaddr_in](lab6/sockaddr.md)
  - [recvfrom()/ sendto()](lab6/recv.md)
  - [close()/ shutdown()](lab6/close.md)
- [Sockets in alte limbaje](lab6/beyond.md)
- [Exerciții](lab6/exercises.md)
- [Extra](lab6/extra.md)

# 06. Transport reliable peste UDP
----
- [Transport reliable peste UDP](lab6/reliable_udp.md)
  
# 07. Protocolul TCP. Multiplexare IO.
----
- [Lectură laborator](lab7/lecture.md)
- [Protocolul TCP](lab7/tcp.md)
  - [Header TCP](lab7/tcp_header.md)
- [API Sockets pentru TCP](lab7/tcp_sockets.md)
  - [connect()](lab7/connect.md)
  - [listen()](lab7/listen.md)
  - [accept()](lab7/accept.md)
  - [send()/recv()](lab7/send.md)
  - [Exemplu client](lab7/client.md)
  - [Exemplu server](lab7/server.md)
- [Multiplexare I/O](lab7/multiplexing.md)
- [Exerciții](lab7/exercises.md)
- [Exerciții 2](lab7/exercises2.md)

# 08. Congestion Control
----

# 09. Protocolul HTTP
----
- [Lectură laborator](lab10/lecture.md)
- [Protocolul HTTP](lab10/http.md)
  - [Cereri HTTP](lab10/http_req.md)
  - [Cookies](lab10/cookies.md)
  - [Raspunsuri HTTP](lab10/responses.md)
  - [Sesiune si autentificare](lab10/session.md)
- [Exerciții](lab10/exercises.md)


# 10. DNS & E-mail
----

# 11. Masurarea performantei
----

# 12. Securitate
----

# 13. QUIC
----
