# Suportul de laborator

Va oferim
[aici](https://gitlab.cs.pub.ro/protocoale-de-comunicatie/pcom-laboratoare-public/-/tree/bogdan_costel.mocanu-master-patch-08393/lab10)
un cod sursă schelet pentru realizarea unui client HTTP scris in C.
Aveti deja implementata partea de realizare de conexiune, partea de
trimitere, respectiv receptionare bytes de la server in *helpers.c* si
*buffer.c*.

Fisierele in care voi veti lucra sunt **client.c** si **requests.c**. In
requests va trebui sa implementati scrierea cererilor de tip GET si POST
si in client trebuie sa trimiteti cererea proaspat compusa catre
destinatie.

Veti interactiona cu doua servere:

  - Serverul principal scris de noi aflat la adresa
    *34.241.4.235* pe portul *8080*
  - API-ul oferit de Openweather Map aflat la adresa *api.openweathermap.org* pe portul *80*

# Exerciții

Pornind de la codul disponibil
[aici](https://gitlab.cs.pub.ro/protocoale-de-comunicatie/pcom-laboratoare-public/-/tree/bogdan_costel.mocanu-master-patch-08393/lab10),
aveți de implementat următoarele cerințe:

1\. Implementati folosind instrucțiunile din îndrumarul de laborator o
cerere dummy de tip GET pentru adresa* /api/v1/dummy* de la serverul principal.

---
**Note**

Gasiti [aici](https://www.cloudshark.org/captures/83390916ab62)
un exemplu de request GET.

---

2\. Implementati folosind instrucțiunile din îndrumarul de laborator o
cerere dummy de tip POST pentru adresa */api/v1/dummy* de la serverul principal
cu cu orice conținut pentru date de forma
**application/x-www-form-urlencoded**.  

---
**Note**

Gasiti
[aici](https://www.cloudshark.org/captures/74a6deb7aa4e?filter=http.request.method%20%3D%3D%20%22POST%22)
o captura cu mesaje de tip POST. Mai multe detalii despre POST gasiti
[aici](https://developer.mozilla.org/en-US/docs/Web/HTTP/Methods/POST)

---

3\. Ne propunem implementarea unei mecanims de autentificare.
Implementați folosind instrucțiunile din îndrumarul de laborator o
cerere de tip POST pentru adresa */api/v1/auth/login* de pe serverul
principal folosind **username** *student* si **password** *student*.
Similar cu task-ul precedent datele trebuie să fie de forma
**application/x-www-form-urlencoded**.

4\. Folosind cookie-ul obtinut la pasul precedent, care poate fi
**hardcodat**, implmentați o cerere de tip GET către adresa */api/v1/weather/key* a serverului
principal pentru a obține un cheia de conectare la serverul *34.241.4.235*.

---
**Note**

Gasiti [aici](https://developer.mozilla.org/en-US/docs/Web/HTTP/Cookies) un
exemplu de mesaj GET cu cookie\]\].

---

5\. Folosind cheia de sesiune, implmentați o cerere de tip **GET** la
serverul *Openweather Map* cu adrese
*/data/2.5/weather* pentru a obține
datele despre vreme. Pentru acest task trebuie specificate coordonatele
(lat,lon) pentru care se dorește obținerea datelor.

6\. Cu date obținute la punctul precedent, implementați o cerere de tip
**POST** la serverul principal (34.241.4.235) pentru verificarea. Pentru
acest task trebuie să țineți cont de faptul că datele servite de
serverul *Openweather Map* sunt în format **JSON**.

7\. Implementați o cerere de tip GET către serverul principal pentru
efectuarea delogări (LogOut) la `/api/v1/auth/logout`

#### Bonus

1.  Implementați un mecanism prin care dacă clientul este deja
    autentificat să primească un mesaj de forma *"Already logged in\!"*.
2.  Folositi [Postman](https://www.postman.com/) pentru a testa
    comenzile HTTP pe care le-ati implementat la laborator. Analizati
    cererile si raspunsurile primite si identificati elementele din
    protocol prezentate la curs si laborator. 
