## Raspunsuri HTTP

Orice cerere HTTP este urmata de un raspuns. Raspunsurile seamana cu
cererile din punct de vedere al organizarii. Formatul este urmatorul:

``` HTTP
    PROTOCOL_VERSION STATUS_CODE STATUS_TEXT\r\n
    Header1: Valoare Header1\r\n
    Header2: Valoare Header2\r\n
    ...
    HeaderN: Valoare HeaderN\r\n
    Set-Cookie: cheie1=valoare1\r\n 
    Set-Cookie: cheie2=valoare2\r\n
    ...
    Set-Cookie: cheieN=valoareN\r\n
    \r\n
    DATA
```

**Linia de start** contine 3 elemente.

Pentru implemenatrea unei răspuns de tip **HTTP POST** pe baza codului
[skelet](https://gitlab.cs.pub.ro/protocoale-de-comunicatie/pcom-laboratoare-public/-/tree/bogdan_costel.mocanu-master-patch-08393/lab10),
trebuie aplelată funcția *compute\_post\_request* cu parametrul
*content\_type = application/x-www-form-urlencoded*.

Primul element este reprezentat de versiunea protocolului de HTTP
folosit pentru a se raspunde.

Al doilea element este reprezentat de **statusul** raspunsului. Statusul
este corelat de reusita, respectiv esecul cererii si de ce s-a intamplat
pe entitatea catre care s-a trimis cererea. Exemplu de statusuri des
intalnite:

  - **200** - OK
  - **201** - Created
  - **204** - No Content
  - **400** - Bad Request
  - **401** - Unauthorized
  - **403** - Forbidden
  - **404** - Resource Not Found
  - **500** - Internal Server Error

Al treilea element descrie textul care insoteste statusul.

**Headerele** urmeaza aceeasi structura si descriu acelasi lucru ca si
in cazul cererilor.

**Cookies** sunt setate cate una pe linie. In afara de *cheie=valoare*,
acestea mai au o serie de atribute atasate, precum **secure**,
**httpOnly**, **domain**.

**Data** urmeaza aceeasi structura ca si in cazul cererilor.
