# Exercitii

**Scheletul laboratorului se regaseste la adresa de
[aici](https://gitlab.cs.pub.ro/protocoale-de-comunicatie/pcom-laboratoare-public/-/tree/master/lab4). Functionalitatea disponibila este descrisa in README.md**

Comanda de mai jos va creea topologia retelei si va prezenta
un prompt prin care se poate interactiona cu topologia si dispozitivele din
aceasta.

```bash
sudo pkill ovs-test
sudo python3 topo.py
```

Se poate interactiona cu hostii prin intermediul promptului mininet, unde se pot
rula comenzi precum **ping**, **wget**, **nc** etc.  Mai multe detalii gasiti in
sectiunea `Testare`.

Pe router va fi rulat programul rezultat in urma rularii comenzii
**make**. In cadrul laboratorului vom lucra in fisierul **router.c**.

**0\.** Folosind instructiunile de mai sus, va trebui sa deschideti o instanta
de Wireshark pe router. Din oricare dintre hosti, trimiteti un `ping`. Din
Wireshark studiati pachetul primit. In toate cele ce urmeaza vom folosi
`Wireshark` pentru a debugging. Este util de stiut faptul ca Wireshark poate
asculta in acelasi timp pe mai multe interfete (avem 4 pe router).

Hostii au urmatoarele adrese alocate:
```
Host  IPv4         MAC   
host0 192.168.0.2  de:ad:be:ef:00:00
host1 192.168.1.2  de:ad:be:ef:00:01
host2 192.168.2.2  de:ad:be:ef:00:02
host3 192.168.3.2  de:ad:be:ef:00:03
```

**1\.** Implementati procesul de forward pentru IPv4. Tabela de rutare este
reprezentata printr-un array si poate fi accesata la un index prin
variabila `rtable[i]`. `rtable_size` este dimensiunea tabelei. Nu trebuie
implementata parsarea fisierului **rtable.txt**. Structura de date
utilizate pentru o intrare din tabela este `rtable_entry` din
`skel.h`.

**1.1.** Verificati integritatea header-ului IP folosind campul de checksum din
header. Daca acesta nu este bun, vom da drop la pachet.

**1.2.** Folosind algoritmul de LPM, determinati urmatorul hop si interfata pe care
va trebui sa trimitem pachetul.

**1.3.** Pentru fiecare pachet scadeti TTL-ul sau Hop Limit-ul; daca TTL-ul
este pozitiv, recalculati checksum-ul.

**1.4.** Actualizati header-ul Ethernet al pachetului. In functie de adresa IP a
destinatiei, vom cauta in tabela MAC adresa MAC a urmatorului hop. Tabela
este statica si putem interactiona cu ea folosind functiile din `skel.h`.

---
**Note**

Puteti folosi inet\_pton a parsa adresele IPv4 sau IPv6 in binar. Pentru a parsa MAC-ul in binar puteti folosi functia hwaddr\_aton pusa la dispozitie in **skel.h**.

Functia int `get_interface_mac(int interface, uint8_t *mac)` intoarce adresa MAC a interfetei router-ului.

---

**2\.** Folosind `Wireshark`, observati schimbarile care au loc
asupra pachetelor de la sursa la destinatie(TTL, checksum,
MAC, etc)