## bind()

Utilizata in server pentru lega un socket de un port si eventual de un
subnet. Pentru a afla mai multe informatii, putem accesa [5.3
bind()—What port am I on?](https://beej.us/guide/bgnet/html/#bind).

``` C
#include <sys/types.h>
#include <sys/socket.h>
   
/*int bind(int sockfd, struct sockaddr *my_addr, int addrlen)*/

struct sockaddr myaddr;
memset(&myaddr, 0, sizeof(servaddr));
myaddr.sin_family = AF_INET; // IPv4
/* INADDR_ANY = 0.0.0.0 as uint32 */
myaddr.sin_addr.s_addr = INADDR_ANY;
myaddr.sin_port = htons(atoi(8888));

int rs = bind(sockfd, myaddr, sizeof(servaddr);
/* in urma apelului, sockfd va avea adresa my_addr */
if (rs == -1) {
  /* trateaza eroare* /
}
```

Explicatii:

* sockfd - Descriptorul de fisier returnat de socket()  
* myaddr - Structura sockaddr ce contine informatii despre adresa IP si port  
* addrlen - lungimea lui my_addr

Observam ca apelul bind utilizeaza o variabila de tip **`struct sockaddr_in`**.
