## close()/ shutdown()

Pentru a inchide un socket se foloseste functia de inchidere a unui
descriptor de fisier din Unix:

``` C
#include <unistd.h>
   
int close(ind fd);
```

Acest lucru va impiedica alte citiri si scrieri din socket. Pentru mai
mult control asupra socketului, se foloseste functia *shutdown()*, care
permite intreruperea comunicatiei selectiv, *schimband modul de
utilizare* a legaturii full-duplex.

Pentru a afla mai multe informatii, putem accesa [5.9 close() and
shutdown()—Get outta my
face\!](https://beej.us/guide/bgnet/html/#close-and-shutdownget-outta-my-face).

``` C
#include <sys/socket.h>
   
int shutdown(int sockfd, int how);
```

Explicatii:

* sockfd - Descriptorul de fisier returnat de socket()  
* how - Specifica modul de inchidere: 0 - Nu se mai citesc date. 1 - Nu se mai pot face transmiteri de date. 2 - Se intrerupe comunicatia in ambele directii.

---
**Note**

Shutdown() nu inchide un descriptor de fisier, ci doar ii schimba modul de utilizare. Resursele trebuie eliberate folosind close()

---