# Exercitii

**1\.** Plecând de la [schelet de
cod](https://gitlab.cs.pub.ro/protocoale-de-comunicatie/pcom-laboratoare-public/-/tree/master/lab6).
 oferit, scrieți o pereche de programe (client și server) care să permită transferul unui
fișier binar de la client la server.

Specificații:

1.  Clientul trimite un fisier binar prin UDP, iar serverul il va
    receptiona datele si le va scrie in fisierul lui. 
2.  Fișierul trimis de client se va numi **fisier.bin**, iar fișierul
    salvat de server se va numi **received_file.bin**.
3.  Clientul va transmite fișierul în calupuri de câte 1024 octeți.

---
**Note**

* Acest exercitiu va fi rulat pe masina locala, nu este necesar sa folositi mininet.

* Pentru a genera fișierul de test folosiți comanda:

    ```bash
    dd if=/dev/urandom of=file.bin bs=512 count=1000
    ```

* Pentru a vedea dacă fișierul s-a trimis corect, folosiți **md5sum**. Sumele de control ale celor 2 fișiere trebuie să fie identice. 
---

**1.1** Vom studia folosind **Wireshark** datagramele trimise de catre
client.

**1.2** Ne vom conecta toti in aceasi retetea (e.g. pe acelasi WiFi) pentru
a trimite datagrame la alti colegi din sala. 
Ne vom **grupa cate doi** pentru a trimite un fisier de la unu la celalalt. 
Mai exact, unul dintre voi va porni un server cu bind pe `INADDR_ANY`
(0.0.0.0), iar clientul va putea trimite catre ip-ul celuilalt un
fisierul. Felicitari, ati facut o **aplicatie simpla de transfer de fisiere**.


**2\.** Dacă ați rulat task-ul 1 cu ambele componente pe aceeași mașină,
probabil totul a mers bine, însă o soluție naivă (care trimite datagrame
doar de la sender la receiver), ascunde 2 probleme:

1.  Dacă transmițătorul este mai rapid decât receptorul, acesta din urma
    poate fi inundat și să nu reușească să proceseze la timp
    datagramele;
2.  Două situații foarte posibile în cazul comunicării către mașini
    diferite (**pierderea unei datagrame** sau **inversarea ordinii
    datagramelor**) sunt netratate.

Pentru a rezolva aceste probleme, vom implementați un protocol de tipul
[stop-and-wait](https://www.isi.edu/nsnam/DIRECTED_RESEARCH/DR_HYUNAH/D-Research/stop-n-wait.html).

---
**Note**

Acest exercitiu va fi rulat peste mininet. Lansați-l doar folosind comanda: `sudo python3 topology.py`.

---

**2.1** Folosind simulatorul de la aceasta
[adresa](https://www2.tkn.tu-berlin.de/teaching/rn/animations/gbn_sr/)
vom simula protocolul stop and wait. Vom selecta urmatorii parametrii in
protocol: protocol selective repeat si windows size 1. Pentru a pierde
un pachet in timpul sumularii vom da click pe acesta.

**2.2** Plecând de la scheletul de cod pentru task-ul 2 implementati
protocolul stop-and-wait. Vom folosi mininet pentru a simula un link
defectuos intre un sender (host 1) si u nreceiver (host 2). Topologia
este un simpla:

``` 
    L1          L2
h1 <--> router <--> h2
```

Link 1 - 10 Mbps, 5ms delay, 5% packet loss

Link 2 - 10 Mbps, 5ms delay, 6% packet loss

---
**Note**

Pentru a obține condiții de rețea relevante (cu limitări de
bandă și pierderi de pachete) rulați acest task cu mininet folosind
comanda `sudo python3 topology.py`

În urma rulării comenzii, vi se vor deschide două terminale, pe două
host-uri având atribuite următoarele adrese:

    h1 - 192.168.1.100
    h2 - 172.16.0.100

---


---
**Note**

Pentru implementarea mecanismelor de timeout necesare, va
trebui ca apelul de recvfrom să nu se mai blocheze la infinit în lipsa
unor noi mesaje (așa cum face implicit). Pentru asta, puteți folosi
**setsockopt** ca mai jos:

``` C
struct timeval tv;
tv.tv_sec = 1;
tv.tv_usec = 0;
setsockopt(sockfd, SOL_SOCKET, SO_RCVTIMEO, (const char *)&tv, sizeof(tv));
```

Ulterior, caz de timeout **recvfrom** va întoarce -1 și va seta errno la
**EAGAIN** sau **EWOULDBLOCK**.

---

### Extra/Hints

* Pentru a intelege mai bine conceptul de byte order, va
recomandam urmatorul articol [byte
order](https://beej.us/guide/bgnet/html/#byte-order)

* Pentru a face trecerea campului `sin_addr` din `struct
sockaddr_in` in string si invers avem functiile: inet\_ntoa si
inet\_aton.

* Observatie: Cateodata, cand se incearca sa se reporneasca un
\_server\_, bind() nu reuseste sa asigneze, iar eroarea este "Address
already in use". Asta inseamna ca un socket care a fost conectat pe acel
port inca mai este agatat si *utilizeaza portul*. In aceasta situatie,
fie se poate astepta deconectarea portului respectiv, fie se specifica
programatic reutilizarea portului cu
[setsockopt()](https://linux.die.net/man/3/setsockopt)

    ``` C
    int enable = 1;
    if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &enable, sizeof(int)) < 0)
        perror("setsockopt(SO_REUSEADDR) failed");
    ```
