Aceste două funcţii se folosesc pentru a transmite date prin sockeţi de
tip stream sau sockeţi datagramă conectaţi. Sintaxa pentru trimitere şi
primire este asemănătoare. Pentru trimitere, se folosește funcția
[send()](https://beej.us/guide/bgnet/html/#sendrecv):

``` C
#include <sys/types.h>
#include <sys/socket.h>

ssize_t send(int connfd, const void *buf, size_t len, int flags);
```

---
**Note**

Atentie la socket-ul pe care send il primeste. Acesta
este socket-ul returnat de accept de la un client. Sockfd il folosim
doar pentru a primi conexiuni de la clienti.

---

Argumentul *connfd* este socketul căruia se dorește să se trimită date
(fie este returnat de apelul *socket()*, fie de apelul *accept()*).
Argumentul *buf* este un pointer către adresa de memorie unde se găsesc
datele ce se doresc a fi trimise, iar argumentul *len* reprezintă
numărul de octeți din memorie începand de la adresa respectivă ce se
vor trimite. Functia *send()* întoarce numărul de octeți efectiv trimiși
(acesta poate fi mai mic decât numărul care s-a precizat că se dorește a
fi trimis, adică *len*). În caz de eroare, funcția returnează -1,
setându-se corespunzător variabila globală *errno*.

Pentru recepție de date, se folosește funcția
[recv()](https://beej.us/guide/bgnet/html/#sendrecv):

``` C
#include <sys/types.h>
#include <sys/socket.h>

ssize_t recv(int connfd, void *buf, size_t len, int flags);
```

În cadrul funcției *recv()*, argumentul *connfd* reprezintă socketul de
unde se citesc datele, *buf* reprezintă un pointer către o adresă din
memorie unde se vor scrie octeții citiți, iar *len* reprezintă numărul
maxim de octeți ce se vor citi. Funcția *recv()* întoarce numărul de
octeți efectiv citiți în *buf* sau -1 în caz de eroare.

Observații:

  - *recv()* poate întoarce și 0, acest lucru însemnând că entitatea cu
    care se comunică a închis conexiunea
  - pentru scrierea/citirea în/din sockeți TCP, se pot folosi cu succes
    și functiile *write()* și *read()* (foarte asemănătoare cu *send()*
    și *recv()*, mai puțin câmpul *flags*, pe care oricum îl setăm pe
    0).